#!/usr/bin/env python

from sys import argv,exit,stdin
from os import getuid
from string import rstrip, join, split
from sss.ssslib import comm_lib, LookupError
from elementtree.ElementTree import Element, XML, tostring
from getopt import getopt, GetoptError
import re



def usage():
    print "Usage: city_power [-d] <on|off|reboot> [-g group1,[group2,...]] [-r restrictions]"
    exit(1)

def power_action(nodelist,action):
    controller_actions = {}

    query = Element('power-control', type=action)
    for node in nodelist:
        newel = Element('node-hardware', node=node, powerdev="*", powerport="*")
        query.append(newel)
    hsh = comm.ClientInit('cluster-hardware')
    comm.SendMessage(hsh,tostring(query))
    answer=comm.RecvMessage(hsh)
    comm.ClientClose(hsh)
    resp = XML(answer)
    if resp.tag != 'node-hardware-set':
        print "Command failed"
    # Returned data is not currently meaningful for returned node status
    #retlist=map(lambda x:x.getAttribute('node'),domobj.documentElement.childNodes)
    #for node in [x for x in retlist if x not in nodelist]:
    #    print "node %s power control failed"%(node)

if __name__ == "__main__":

    argre = re.compile(
        "^(-d\s+)?(?P<action>\S+)\s+(-g\s+(?P<group>\S+,?)+\s*)?(-r\s+(?P<restrictions>(\S+=\S+ {0,1})*))?$")
    optmatch = argre.match(join(argv[1:]," "))
    groups=[]
    if optmatch:
        action=optmatch.group("action")
        group=optmatch.group('group')
        if group:
            groups=split(group, ',')
        restrictions=[]
        restr=optmatch.group('restrictions')
        if restr:
            restrictions=split(restr)
        if (not group and not restrictions) or not action:
            usage()
    else:
        usage()

    comm = comm_lib(debug=('-d' in argv))
    bsh = comm.ClientInit('build-system')

    nodelist=[]
    nodelist2=[]
    if groups:
        query = Element('get-tag')
        for group in groups:
            query.append(Element('tag', name=group, node='*'))
        comm.SendMessage(bsh,tostring(query))
        ans = comm.RecvMessage(bsh)
        answer = XML(ans)
        nodelist = [x.attrib['node'] for x in answer]
    if restrictions:
        query = Element('get-node-software')
        for rest in restrictions:
            elem = Element('node-software')
            (key,val)=split(rest,'=')
            elem.attrib[key]=val
            query.append(elem)
        comm.SendMessage(bsh,tostring(query))
        answer = XML(comm.RecvMessage(bsh))
        # Build list of nodes not returned in the first nodelist
        nodelist2 = [x.attrib['node'] for x in answer if x.attrib['node'] not in nodelist]

    comm.ClientClose(bsh)
    nodelist += nodelist2
    if nodelist:
        pass
        power_action(nodelist,action)
    else:
        print "No nodes matched"
